<!DOCTYPE html>
<html lang="en" prefix="og: http://ogp.me/ns#">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
  <meta http-equiv="Content-Language" content="en-us" />
  <meta http-equiv="imagetoolbar" content="false" />
  <meta name="MSSmartTagsPreventParsing" content="true" />
  <meta name="viewport" content="width=device-width,initial-scale=1">
  <title>Introduction to GraphQL | GitHub Developer Guide</title>
  <meta property="og:url" content="https://developer.github.com/v4/guides/intro-to-graphql/" />
<meta property="og:site_name" content="GitHub Developer" />
<meta property="og:title" content="Introduction to GraphQL" />
<meta property="og:description" content="Get started with one of our guides, or jump straight into the API documentation." />
<meta property="og:type" content="website" />
<meta property="og:author" content="https://www.facebook.com/GitHub" />
<meta property="og:image" content="https://og.github.com/logo/github-logo@1200x1200.png" />
<meta property="og:image:width" content="1200" />
<meta property="og:image:height" content="1200" />
<meta property="og:image" content="https://og.github.com/mark/github-mark@1200x630.png" />
<meta property="og:image:width" content="1200" />
<meta property="og:image:height" content="630" />
<meta property="og:image" content="https://og.github.com/octocat/github-octocat@1200x630.png" />
<meta property="og:image:width" content="1200" />
<meta property="og:image:height" content="630" />
<meta property="twitter:card" content="summary_large_image" />
<meta property="twitter:site" content="@github" />
<meta property="twitter:site:id" content="13334762" />
<meta property="twitter:creator" content="@githubapi" />
<meta property="twitter:creator:id" content="@539153822" />
<meta property="twitter:title" content="Introduction to GraphQL" />
<meta property="twitter:description" content="Get started with one of our guides, or jump straight into the API documentation." />
<meta property="twitter:image:src" content="https://og.github.com/logo/github-logo@1200x1200.png" />
<meta property="twitter:image:width" content="1200" />
<meta property="twitter:image:height" content="1200" />

  
  <link rel="alternate" type="application/atom+xml" title="API Changes" href="/changes.atom" />
  
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:400,300,400italic,500">
  <link href="/assets/stylesheets/application.css" rel="stylesheet" type="text/css" />
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/2.1.4/jquery.min.js"></script>
  <script src="/assets/javascripts/application.js" type="text/javascript"></script>
  
</head>


<body class="api ">
  

<header class="site-header">
  <div id="header" class="container">
    <a class="site-header-logo mt-1" href="/"><img src="/assets/images/github-developer-logo.svg" alt="GitHub Developer"></a>
    <nav class="site-header-nav" aria-label="Main Navigation">
      <div class="dropdown" id="api-docs-dropdown">
          <div class="dropdown-button" tabIndex="0" aria-haspopup="true" aria-expanded="false"><span class="dropdown-button-link" tabIndex="-1">Docs</span> <div class="dropdown-caret"></div></div>
          <div id="js-dropdown-menu" class="dropdown-menu">
            <a class="dropdown-menu-item" href="/apps/">Apps</a>
            <a class="dropdown-menu-item" href="/actions/">GitHub Actions</a>
            <a class="dropdown-menu-item" href="/marketplace/">GitHub Marketplace</a>
            <a class="dropdown-menu-item" href="/webhooks/">Webhooks</a>
            <a class="dropdown-menu-item" href="/partnerships/">Partnerships</a>
            <a class="dropdown-menu-item" href="/v3/">REST API v3</a>
            <a class="dropdown-menu-item" href="/v4/">GraphQL API v4</a>
          </div>
      </div>
      <a class="site-header-nav-item" href="/changes/">Blog</a>
      <a class="site-header-nav-item" href="/forum/">Forum</a>
      <div class="dropdown" id="versions-dropdown">
          <div class="dropdown-button" tabIndex="0" aria-haspopup="true" aria-expanded="false"><span class="dropdown-button-link" tabIndex="-1">Versions</span> <div class="dropdown-caret"></div></div>
          <div id="js-dropdown-menu" class="dropdown-menu">
            <a class="dropdown-menu-item" data-proofer-ignore>GitHub.com</a>
            
            <a class="dropdown-menu-item" data-proofer-ignore>GitHub Enterprise Server 2.20</a>
            
            <a class="dropdown-menu-item" data-proofer-ignore>GitHub Enterprise Server 2.19</a>
            
            <a class="dropdown-menu-item" data-proofer-ignore>GitHub Enterprise Server 2.18</a>
            
            <a class="dropdown-menu-item" data-proofer-ignore>GitHub Enterprise Server 2.17</a>
            
          </div>
      </div>
      <form accept-charset="UTF-8" action="#" class="site-header-nav-item site-header-search">
        <label id="search-container" class="mb-0">
          <input type="text" id="searchfield" class="form-control" placeholder="Search…"
            autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false" />
          <div class="cancel-search"></div>
          <ul id="search-results"></ul>
        </label>
      </form>
    </nav>
  </div>
</header>


  <div class="container">
    

























  

 







    <div class="sub-nav mt-5 mb-3">
      <h2><a href="/v4/">GraphQL API v4</a></h2>
      <ul>
  
  <li><a href="/v4/">Reference</a></li>
  <li><a href="/v4/guides/" class="active">Guides</a></li>
  
  <li><a href="/v4/explorer/">Explorer</a></li>
  <li><a href="/v4/changelog/">Changelog</a></li>
  
  
</ul>

    </div>

    <div class="nav-select nav-select-top hide-lg hide-xl">
      <select class="form-select mt-4" onchange="if (this.value) window.location.href=this.value">
  <option value="">Navigate the docs…</option>
  <optgroup label="Guides">
    <option value="/v4/guides/">Overview</option>
    <option value="/v4/guides/intro-to-graphql/">Intro to GraphQL</option>
    <option value="/v4/guides/forming-calls/">Forming Calls</option>
    <option value="/v4/guides/using-global-node-ids/">Using Global Node IDs</option>
    <option value="/v4/guides/migrating-from-rest/">Migrating from REST</option>
    <option value="/v4/guides/using-the-explorer/">Using the Explorer</option>
    <option value="/v4/guides/managing-enterprise-accounts/">Managing enterprise accounts</option>
    <option value="/v4/guides/resource-limitations/">Resource Limitations</option>
  </optgroup>
</select>

    </div>

    <section class="main pt-5 clearfix gut-3" role="main">
      <div class="content col-md-8">
        <h1>
<a id="introduction-to-graphql" class="anchor" href="#introduction-to-graphql" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Introduction to GraphQL</h1>

<ul id="markdown-toc">
<li><a href="#graphql-terminology" id="markdown-toc-graphql-terminology">GraphQL terminology</a></li>
<li><a href="#discovering-the-graphql-api" id="markdown-toc-discovering-the-graphql-api">Discovering the GraphQL API</a></li>
</ul>

<h2>
<a id="graphql-terminology" class="anchor" href="#graphql-terminology" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>GraphQL terminology</h2>

<p>The GitHub GraphQL API v4 represents an architectural and conceptual shift from the GitHub REST API v3. You will likely encounter some new terminology in the GraphQL API v4 <a href="/v4/">reference docs</a>.</p>

<h3>
<a id="schema" class="anchor" href="#schema" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Schema</h3>

<p>A schema defines a GraphQL API's type system. It describes the complete set of possible data (objects, fields, relationships, everything) that a client can access. Calls from the client are <a href="https://graphql.github.io/learn/validation/">validated</a> and <a href="https://graphql.github.io/learn/execution/">executed</a> against the schema. A client can find information about the schema via <a href="#discovering-the-graphql-api">introspection</a>. A schema resides on the GraphQL API server. For more information, see "<a href="#discovering-the-graphql-api">Discovering the GraphQL API</a>."</p>

<h3>
<a id="field" class="anchor" href="#field" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Field</h3>

<p>A field is a unit of data you can retrieve from an object. As the <a href="https://graphql.github.io/learn/schema/">official GraphQL docs</a> say:
"The GraphQL query language is basically about selecting fields on objects."</p>

<p>The <a href="https://graphql.github.io/graphql-spec/June2018/#sec-Language.Fields">official spec</a> also says about fields:</p>

<blockquote>
<p>All GraphQL operations must specify their selections down to fields which return scalar values to ensure an unambiguously shaped response.</p>
</blockquote>

<p>This means that if you try to return a field that is not a scalar, schema validation will throw an error. You must add nested subfields until all fields return scalars.</p>

<h3>
<a id="argument" class="anchor" href="#argument" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Argument</h3>

<p>An argument is a set of key-value pairs attached to a specific field. Some fields require an argument. <a href="/v4/guides/forming-calls#about-mutations">Mutations</a> require an input object as an argument.</p>

<h3>
<a id="implementation" class="anchor" href="#implementation" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Implementation</h3>

<p>A GraphQL schema may use the term <em>implements</em> to define how an object inherits from an <a href="/v4/interface">interface</a>.</p>

<p>Here's a contrived example of a schema that defines interface <code>X</code> and object <code>Y</code>:</p>

<pre><code>interface X {
  some_field: String!
  other_field: String!
}

type Y implements X {
  some_field: String!
  other_field: String!
  new_field: String!
}
</code></pre>

<p>This means object <code>Y</code> requires the same fields/arguments/return types that interface <code>X</code> does, while adding new fields specific to object <code>Y</code>. (The <code>!</code> means the field is required.)</p>

<p>In the reference docs, you'll find that:</p>

<ul>
<li><p>Each <a href="/v4/object">object</a> lists the interface(s) <em>from which it inherits</em> under <strong>Implements</strong>.</p></li>
<li><p>Each <a href="/v4/interface">interface</a> lists the objects <em>that inherit from it</em> under <strong>Implementations</strong>.</p></li>
</ul>

<h3>
<a id="connection" class="anchor" href="#connection" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Connection</h3>

<p>Connections let you query related objects as part of the same call. With connections, you can use a single GraphQL call where you would have to use multiple calls to a REST API. For more information, see "<a href="/v4/guides/migrating-from-rest">Migrating from REST to GraphQL</a>."</p>

<p>It's helpful to picture a graph: dots connected by lines. The dots are nodes, the lines are edges. A connection defines a relationship between nodes.</p>

<h3>
<a id="edge" class="anchor" href="#edge" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Edge</h3>

<p>Edges represent connections between nodes. When you query a connection, you traverse its edges to get to its nodes. Every <code>edges</code> field has a <code>node</code> field and a <code>cursor</code> field. Cursors are used for <a href="https://graphql.github.io/learn/pagination/">pagination</a>.</p>

<h3>
<a id="node" class="anchor" href="#node" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Node</h3>

<p><em>Node</em> is a generic term for an object. You can look up a node directly, or you can access related nodes via a connection. If you specify a <code>node</code> that does not return a <a href="/v4/scalar">scalar</a>, you must include subfields until all fields return scalars. For information on accessing node IDs via the REST API v3 and using them in GraphQL queries, see "<a href="/v4/guides/using-global-node-ids">Using Global Node IDs</a>."</p>

<h2>
<a id="discovering-the-graphql-api" class="anchor" href="#discovering-the-graphql-api" aria-hidden="true"><span aria-hidden="true" class="octicon octicon-link"></span></a>Discovering the GraphQL API</h2>

<p>GraphQL is <a href="https://graphql.github.io/learn/introspection/">introspective</a>. This means you can query a GraphQL schema for details about itself.</p>

<ul>
<li>Query <code>__schema</code> to list all types defined in the schema and get details about each:</li>
</ul>

<p class="explorer-link"><a href="/v4/explorer/?variables=%7B%7D&amp;query=query%20%7B%0A%20%20__schema%20%7B%0A%20%20%20%20types%20%7B%0A%20%20%20%20%20%20name%0A%20%20%20%20%20%20kind%0A%20%20%20%20%20%20description%0A%20%20%20%20%20%20fields%20%7B%0A%20%20%20%20%20%20%20%20name%0A%20%20%20%20%20%20%7D%0A%20%20%20%20%7D%0A%20%20%7D%0A%7D">Run in Explorer</a></p>

<pre class="highlight highlight-graphql"><code><span class="k">query</span><span class="w"> </span><span class="p">{</span><span class="w">
  </span><span class="n">__schema</span><span class="w"> </span><span class="p">{</span><span class="w">
    </span><span class="n">types</span><span class="w"> </span><span class="p">{</span><span class="w">
      </span><span class="n">name</span><span class="w">
      </span><span class="n">kind</span><span class="w">
      </span><span class="n">description</span><span class="w">
      </span><span class="n">fields</span><span class="w"> </span><span class="p">{</span><span class="w">
        </span><span class="n">name</span><span class="w">
      </span><span class="p">}</span><span class="w">
    </span><span class="p">}</span><span class="w">
  </span><span class="p">}</span><span class="w">
</span><span class="p">}</span><span class="w">
</span></code></pre>


<ul>
<li>Query <code>__type</code> to get details about any type:</li>
</ul>

<p class="explorer-link"><a href="/v4/explorer/?variables=%7B%7D&amp;query=query%20%7B%0A%20%20__type%28name%3A%20%22Repository%22%29%20%7B%0A%20%20%20%20name%0A%20%20%20%20kind%0A%20%20%20%20description%0A%20%20%20%20fields%20%7B%0A%20%20%20%20%20%20name%0A%20%20%20%20%7D%0A%20%20%7D%0A%7D">Run in Explorer</a></p>

<pre class="highlight highlight-graphql"><code><span class="k">query</span><span class="w"> </span><span class="p">{</span><span class="w">
  </span><span class="n">__type</span><span class="p">(</span><span class="n">name</span><span class="p">:</span><span class="w"> </span><span class="s2">"Repository"</span><span class="p">)</span><span class="w"> </span><span class="p">{</span><span class="w">
    </span><span class="n">name</span><span class="w">
    </span><span class="n">kind</span><span class="w">
    </span><span class="n">description</span><span class="w">
    </span><span class="n">fields</span><span class="w"> </span><span class="p">{</span><span class="w">
      </span><span class="n">name</span><span class="w">
    </span><span class="p">}</span><span class="w">
  </span><span class="p">}</span><span class="w">
</span><span class="p">}</span><span class="w">
</span></code></pre>


<ul>
<li>
<p>You can also run an <em>introspection query</em> of the schema via a <code>GET</code> request:</p>

<pre class="command-line">
<span class="command">curl -H "Authorization: bearer <em>token</em>" https://api.github.com/graphql</span>
</pre>

<p>The results are in JSON, so we recommend pretty-printing them for easier reading and searching. You can use a command-line tool like <a href="https://stedolan.github.io/jq/">jq</a> or pipe the results into <code>python -m json.tool</code> for this purpose.</p>

<p>Alternatively, you can pass the <code>idl</code> media type to return the results in IDL format, which is a condensed version of the schema:</p>

<pre class="command-line">
<span class="command">curl -H "Authorization: bearer <em>token</em>" -H "Accept: application/vnd.github.v4.idl" \</span>
https://api.github.com/graphql
</pre>
</li>
</ul>

<div class="alert note">

<p><strong>Note</strong>: The introspection query is probably the only <code>GET</code> request you'll run in GraphQL. If you're passing a body, the GraphQL request method is <code>POST</code>, whether it's a query or a mutation.</p>

</div>

<p>For more information about performing queries, see "<a href="/v4/guides/forming-calls">Forming calls with GraphQL</a>."</p>
      </div>

      <div class="nav-select nav-select-bottom hide-lg hide-xl">
        <select class="form-select mt-4" onchange="if (this.value) window.location.href=this.value">
  <option value="">Navigate the docs…</option>
  <optgroup label="Guides">
    <option value="/v4/guides/">Overview</option>
    <option value="/v4/guides/intro-to-graphql/">Intro to GraphQL</option>
    <option value="/v4/guides/forming-calls/">Forming Calls</option>
    <option value="/v4/guides/using-global-node-ids/">Using Global Node IDs</option>
    <option value="/v4/guides/migrating-from-rest/">Migrating from REST</option>
    <option value="/v4/guides/using-the-explorer/">Using the Explorer</option>
    <option value="/v4/guides/managing-enterprise-accounts/">Managing enterprise accounts</option>
    <option value="/v4/guides/resource-limitations/">Resource Limitations</option>
  </optgroup>
</select>

      </div>

      <div id="js-sidebar" class="sidebar-shell col-md-4 hide-sm hide-md d-md-block d-lg-block d-xl-block">
        <div class="sidebar-module sidebar-menu">
          <ul>
            <li class="js-topic"><h3 class="standalone"><a href="/v4/guides/">Overview</a></h3></li>
            <li class="js-topic"><h3 class="standalone"><a href="/v4/guides/intro-to-graphql/">Intro to GraphQL</a></h3></li>
            <li class="js-topic"><h3 class="standalone"><a href="/v4/guides/forming-calls/">Forming Calls</a></h3></li>
            <li class="js-topic"><h3 class="standalone"><a href="/v4/guides/using-global-node-ids/">Using Global Node IDs</a></h3></li>
            <li class="js-topic"><h3 class="standalone"><a href="/v4/guides/migrating-from-rest/">Migrating from REST</a></h3></li>
            <li class="js-topic"><h3 class="standalone"><a href="/v4/guides/using-the-explorer/">Using the Explorer</a></h3></li>
            <li class="js-topic"><h3 class="standalone"><a href="/v4/guides/managing-enterprise-accounts/">Managing enterprise accounts</a></h3></li>
            <li class="js-topic"><h3 class="standalone"><a href="/v4/guides/resource-limitations/">Resource Limitations</a></h3></li>
          </ul>
        </div>

        
        <div class="sidebar-module api-status py-4 text-center"><a href="https://status.github.com" class="unknown">API Status</a></div>

        
      </div><!-- sidebar-shell -->
    </section>
  </div>

  <footer class="footer text-muted">
  <div class="container">
    <span class="footer-legal">&copy; 2020 GitHub Inc. All rights reserved.</span>
    <span class="mega-octicon octicon-mark-github footer-mark"></span>
    <nav class="footer-nav">
      <a class="footer-nav-item" href="https://help.github.com/articles/github-terms-of-service">Terms of service</a>
      <a class="footer-nav-item" href="https://github.com/site/privacy">Privacy</a>
      <a class="footer-nav-item" href="https://github.com/security">Security</a>
      <a class="footer-nav-item" href="https://github.com/support">Support</a>
    </nav>
  </div>
</footer>

<script>
  (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
  (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
  m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
  })(window,document,'script','//www.google-analytics.com/analytics.js','ga');

  ga('create', 'UA-3769691-37', 'github.com');
  ga('send', 'pageview');
</script>

</body>
</html>
